-- **************************************************************************
-- * PalaReminder
-- * by evil.oz
-- *
-- * v1.3
-- *************************************************************************
-- 
-- Addon that warns fellow paladins the follow: 
-- 
-- you have crusader aura when entering in combat
-- you have no aura when entering in combat
-- 
-- you dont have righteous fury and u are probably in tanking gear (only in group)
-- 
-- 
-- #########################################################################################################
-- onload handler
-- #########################################################################################################
function PalaReminder_OnLoad()

	local cls, class = UnitClass("player");

	if (class == "PALADIN") then
		this:RegisterEvent("PLAYER_REGEN_DISABLED");
		this:RegisterEvent("VARIABLES_LOADED");
		this:RegisterEvent("PLAYER_AURAS_CHANGED");
		PalaReminder_Crusader="Crusader Aura"
		PalaReminder_Fury="Righteous Fury"
		PalaReminder_Aura="Aura"
		DEFAULT_CHAT_FRAME:AddMessage("PalaReminder v1.3 load successful", 1.0, 1.0, 0.0);
	else
		DEFAULT_CHAT_FRAME:AddMessage("PalaReminder v1.3 disabled, not a paladin", 1.0, 1.0, 0.0);
	end

end


function  PalaReminder_CheckFury(x)



		local i
		local def=GetCombatRatingBonus(2)  --CR_DEFENSE_SKILL
		local ingroup= GetNumPartyMembers() + GetNumRaidMembers()

--DEFAULT_CHAT_FRAME:AddMessage("Your defense: "..def)
--DEFAULT_CHAT_FRAME:AddMessage("Members in group: "..ingroup)

		if ((def > 25) and (ingroup>0)) then
			i=string.find(x,PalaReminder_Fury)
			if (i) then
			else
				PalaReminder_Message("NO RIGHTEOUS FURY!!");
--				DEFAULT_CHAT_FRAME:AddMessage("[PalaReminder] Tanking without Righteous Fury !!!")
				PlaySoundFile("Sound\\interface\\mapping.wav")
			end
		end

end


-- #########################################################################################################
-- main event routine
-- #########################################################################################################
function PalaReminder_OnEvent(event)


	if (event == "VARIABLES_LOADED") then

		DEFAULT_CHAT_FRAME:AddMessage("PalaReminder v1.3 loaded sucessful", 1.0, 1.0, 0.0);

	end



	if (event == "PLAYER_REGEN_DISABLED") then


		if (class == "PALADIN") then 
			--entering combat

			local i,x =  1,"";
	

			local classe, class = UnitClass("player");

			while (UnitBuff("player",i) ~= nil) do
				x = x .. UnitBuff("player",i) .. " ";
				i = i + 1;
			end

			if (i > 0) then
				i=string.find(x,PalaReminder_Crusader)
				if (i) then
					if not IsMounted() then
						PalaReminder_Message("CRUSADER AURA!!");
						PlaySoundFile("Sound\\interface\\mapping.wav")
					end
				else
					i=string.find(x,PalaReminder_Aura)			
					if (not i) then 
						PalaReminder_Message("NO AURA SET!!");
						PlaySoundFile("Sound\\interface\\mapping.wav")
					end
				end
			end

			PalaReminder_CheckFury(x)
		end
	end


	if (event == "PLAYER_AURAS_CHANGED") then


		local i,x =  1,"";


		local classe, class = UnitClass("player");

		if (class == "PALADIN") then 
		
			while (UnitBuff("player",i) ~= nil) do
				x = x .. UnitBuff("player",i) .. " ";
				i = i + 1;
			end


			if (i > 0) then
				i=string.find(x,PalaReminder_Aura)
				if (not i) then
					PalaReminder_Message("NO AURA SET!!");
					PlaySoundFile("Sound\\interface\\mapping.wav")
				end
			end

			PalaReminder_CheckFury(x)
		end

	end

end



-- #########################################################################################################
-- misc service functions
-- #########################################################################################################


function PalaReminder_Message(msg)
	UIErrorsFrame:AddMessage(msg, 0, 1.0, 1.0, 1.0, 1);
end